<template lang="pug">
  .issue-detail.pa4.relative.vh-100.mw9.center
    b-loading(:active="isLoading" :is-full-page="false")
    .h-100(v-if="detail")
      .flex.items-center.justify-between.flex-wrap
        .left.flex.items-center
          b-button.issue-detail__prev(type="is-text" icon-right="chevron-left" @click="$router.go(-1)" title="上一頁")
          .dim.pointer(@click="openStateSwitcher")
            state-tag(:value="state")
          h1.f4.mv0
            .dib.ml3.b {{house}} {{detail.roomId}}&nbsp;
            .dib.normal 的
            .dib.b {{issueType}}問題
        .right.tr.w-100.w-auto-l.flex.flex-wrap.items-center
          b-taglist(attached)
            b-tag(type="is-white") 通報
            b-tag(type="is-success") {{createdAgo}}
          external-link.dim.pointer(:href="stateUrl")
            b-tag(type="is-white" outlined)
              span 公開進度查詢
              b-icon(icon="external-link-alt" size="is-small")
          .w5
      .flex.mv3
        .flex-auto.ba.b--light-silver.bg-white.br2
          b-tabs(v-model="activeTab" :destroy-on-hide="true")
            b-tab-item(label="詳細資料")
              issue-detail-tab(:item="detail")
            b-tab-item(label="聯絡室友")
              issue-chat-tab(v-if="hasChat" :item="detail" @state-changed="handleStateChanged")
              .pa3(v-else)
                b-notification(type="is-warning" :closable="false")
                  .tc.ma4
                    .f4 ●︿●
                    .mt3.mid-gray 此通報尚未綁定 Messenger
          state-switcher(:active.sync="stateSwitcherOpend" :itemId="issueId" :stateName="state" @changed="handleStateChanged")
        .w5.pl4
          related-issues(
            v-if="detail.booking"
            :booking="detail.booking"
            :curIssueId="issueId"
          )

</template>
<script>
import moment from 'moment'
import { adminMixin, issueMixin } from '~/utils/mixins'
import api from '~/utils/api'
import ExternalLink from '~/components/ExternalLink'
import StateTag from '~/components/StateTag'
import IssueDetailTab from '~/components/IssueDetailTab'
import IssueChatTab from '~/components/IssueChatTab'
import StateSwitcher from '~/components/StateSwitcher'
import RelatedIssues from '~/components/RelatedIssues'

export default {
  components: {
    StateTag,
    IssueDetailTab,
    IssueChatTab,
    StateSwitcher,
    ExternalLink,
    RelatedIssues
  },
  mixins: [adminMixin, issueMixin],
  layout: 'private',
  data () {
    return {
      isLoading: false,
      detail: null,
      activeTab: 0,
      stateSwitcherOpend: false
    }
  },
  computed: {
    issueId () {
      return this.$route.params.ticketId
    },
    state () {
      return this.detail.state
    },
    stateType () {
      return this.getStateType(this.state)
    },
    hasChat () {
      return this.detail.booking && this.detail.booking.channelId
    },
    house () {
      return this.zh(this.detail.buildingId)
    },
    issueType () {
      return this.zh(this.detail.taskType)
    },
    stateUrl () {
      return `/item-state/${this.issueId}`
    },
    createdAgo () {
      return moment(this.detail.reportedAt).fromNow()
    }
  },
  watch: {
    issueId () {
      this.getDetail()
    }
  },
  created () {
    this.getDetail()
  },
  methods: {
    async getDetail () {
      this.isLoading = true
      this.detail = await api.issue.get(this.issueId)
      this.isLoading = false
    },
    openStateSwitcher () {
      this.stateSwitcherOpend = true
    },
    handleStateChanged () {
      this.getDetail()
    }
  }
}
</script>
<style lang="scss" scoped>
.issue-detail {
  &__prev {
    text-decoration: none;
    outline: none;
    &:hover {
      background: none;
    }
  }
  .right .tags {
    margin-bottom: 0;

    &:not(:last-child) {
      margin-right: 0.3em;
    }

    .tag {
      margin-bottom: 0;
    }
  }
  /deep/ {
    .tab-item {
      height: calc(100vh - 11rem);
      overflow-y: auto;
    }
    .tabs li a {
      border-bottom: 3px solid transparent;
    }
    .tabs li.is-active a {
      color: black;
      font-weight: bold;
      border-color: #FF6300;
    }
    .b-tabs .tab-content {
      padding: 0;
    }
    .b-tabs:not(:last-child) {
      margin-bottom: 0;
    }
  }
}
</style>
